Subject: Re: Git: How to keep multiple bare repos in sync?

From: Junio C Hamano <[email-masked]>
Date: Tue, 12 May 2015 21:37:45 -0700

chenxitwo <[email-masked]> writes:

> There are three git server(bare repos), but i don't know to solve the
> problem that how to keep these git servers in sync.

rsync?

The problem is under-specified.  Is there one of them that is
authoritative and that the other ones should match its progress?
If so, perhaps push from the authoritative one to the other two
with "push --mirror" (or have the other ones "fetch --mirror")?

If you are allowing people to push into any of them randomly,
then there is no general solution.  If I push an update to 'master'
of instance A while you update the same 'master' branch of instance
B, somebody has to reconcile the divergence between the two by
creating a merge, and that can possibly conflict, needing human
intervention to resolve.